clang 8.0.0

Public Member Functions | List of all members
clang::ExternalPreprocessorSource Class Referenceabstract

Abstract interface for external sources of preprocessor information. More...

`#include "clang/Lex/ExternalPreprocessorSource.h"`

Inheritance diagram for clang::ExternalPreprocessorSource:
[legend]

## Public Member Functions
virtual | ~ExternalPreprocessorSource ()
virtual void | ReadDefinedMacros ()=0
| Read the set of macros defined by this external macro source. More...
virtual void | updateOutOfDateIdentifier (IdentifierInfo &II)=0
| Update an out-of-date identifier. More...
virtual IdentifierInfo * | GetIdentifier (unsigned ID)=0
| Return the identifier associated with the given ID number. More...
virtual Module * | getModule (unsigned ModuleID)=0
| Map a module ID to a module. More...

## Detailed Description

Abstract interface for external sources of preprocessor information.

This abstract class allows an external sources (such as the `ASTReader`) to provide additional preprocessing information.

Definition at line 27 of file ExternalPreprocessorSource.h.

## Constructor & Destructor Documentation

## ◆ ~ExternalPreprocessorSource()

ExternalPreprocessorSource::~ExternalPreprocessorSource | ( |  | ) |
| virtual default

## Member Function Documentation

## ◆ GetIdentifier()

virtual IdentifierInfo* clang::ExternalPreprocessorSource::GetIdentifier | ( | unsigned | ID | ) |
| pure virtual

Return the identifier associated with the given ID number.

The ID 0 is associated with the NULL identifier.

Referenced by clang::HeaderFileInfo::getControllingMacro().

## ◆ getModule()

virtual Module* clang::ExternalPreprocessorSource::getModule | ( | unsigned | ModuleID | ) |
| pure virtual

Map a module ID to a module.

Implemented in clang::ASTReader.

## ◆ ReadDefinedMacros()

virtual void clang::ExternalPreprocessorSource::ReadDefinedMacros | ( |  | ) |
| pure virtual

Read the set of macros defined by this external macro source.

Implemented in clang::ASTReader.

Referenced by clang::Preprocessor::macro_begin(), and clang::Preprocessor::macro_end().

## ◆ updateOutOfDateIdentifier()

virtual void clang::ExternalPreprocessorSource::updateOutOfDateIdentifier | ( | IdentifierInfo & | II | ) |
| pure virtual

Update an out-of-date identifier.

Implemented in clang::ASTReader.

Referenced by clang::HeaderFileInfo::getControllingMacro(), getFutureCompatDiagKind(), and isTrivialSingleTokenExpansion().

The documentation for this class was generated from the following files:

- include/clang/Lex/ExternalPreprocessorSource.h
- lib/Lex/Preprocessor.cpp